/*		CUT save	*/
/*	for coerce x68k	*/
/*		1999 Rick	*/

#include	<stdio.h>
#include	<string.h>
#include	"defs.h"
#include	"CUT.h"

static unsigned char	header[] =
	 "CUT_V1.0(0000,0000)coerce X68k revision 8    \r\n\x1a";

extern void	error(char*);

void	CUTSave();
static void	cutwrite();
static void	bitpack();
static void	numwrite();


void
CUTSave()
{
/*	if (MaxColorGuaranteed > 2)	error("not 2 colors"); */

	if (!fp)
		if (!(fp = fopen(File, "wb")))	error("cannot create");

	if (Width > 1024 || Height > 1024)	error("too large");
	numwrite(header + 12, Width);
	numwrite(header + 17, Height);

	header[48] = Width >> 8;
	header[49] = Width & 0xff;
	header[50] = Height >> 8;
	header[51] = Height & 0xff;

	if (fwrite(header, sizeof(unsigned char), 52, fp) != 52)
		error("Error in writing");

	bitpack();
	cutwrite();

	if (fp != stdout)	fclose(fp);
}

static void
numwrite(buf, num)
char	*buf;
int	num;
{
	char	*tmp= buf;
	int	i, j;

	i = num;

	while (i){
		j = i % 10;
		i /= 10;

		*tmp-- = (char)(j + '0');
	}
}

static void
bitpack()
{
	int	x, y;
	unsigned char	*r, *w;

	w = r = (unsigned char*)Screen;
	for (y = 0; y < Height; y++) {
		unsigned char	bitct = 8, bits;

		for (x = 0; x < Width; x++) {
			bits += bits;
			if (*r++)	bits |= 1;
			if (!--bitct) {
				*w++ = bits;
				bitct = 8;
			}
		}
		if (bitct &= 7)	*w++ = bits << bitct;
	}
}

static void
cutwrite()
{
	short	y, x, flagsize, bodysize;
	unsigned char	buf[146], *top, *prev;

	bodysize = (Width + 7) >> 3;
	flagsize = (bodysize + 7) >> 3;
	prev = buf + 17;
	for (x = 0; x < bodysize; x++)	prev[x] = 0;

	top= (unsigned char*)Screen;
	for (y = 0; y < Height; y++) {
		short	bitct;
		unsigned char	*p, *f, *body, flag, ct;

		p = prev;
		prev = top;
		f = buf + 1;
		body = f + flagsize;
		bitct = 8;
		for (x = 0; x < bodysize; x++) {
			unsigned char	data;

			flag += flag;
			if (data = (*top++) ^ *p++) {
				flag |= 1;
				*body++ = data;
			}
			if (!--bitct) {
				*f++ = flag;
				bitct = 8;
			}
		}
		if (bitct &= 7)	*f++ = flag << bitct;

		if (ct = (int)(body - f)) {
			ct += flagsize + 1;
			buf[0] = ct;
			if (fwrite(buf, sizeof(unsigned char), ct, fp) != ct)
				error("Error in writing");
		} else {
			if (fputc(1, fp) < 0)	error("Error in writing");
		}
	}
}
