*	CUTLoad.s

RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include	doscall.mac

HEADSIZ	equ	52

	.text

	.even
	.globl	_CUTLoad
_CUTLoad:
	link	a6,#-256	*bit buffer
	movem.l	d3-d6/a3-a5,-(sp)

	suba.l	a4,a4		*error message pointer init
	movea.l	a4,a2		*virtual gram
	movea.l	a4,a5		*file buffer
	moveq.l	#0,d5		*file handle init
	tst.l	_fp		*stdin ?
	bne	@f

	clr.w	-(sp)		*read mode
	move.l	_File,-(sp)	*file name
	DOS	__OPEN
	addq.w	#6,sp
	move.l	d0,d5
	bpl	@f		*file handle

	lea	eopen(OPC),a4	*set error message
	bra	load_end
@@
	moveq.l	#HEADSIZ,d3	*header size
	move.l	d3,-(sp)
	lea	-256(a6),a3	*header buffer
	move.l	a3,-(sp)
	move.w	d5,-(sp)	*file handle
	DOS	__READ
	lea	10(sp),sp
	cmp.l	d0,d3		*read exact size ?
	bne	read_err

	move.l	(a3),d0
	cmpi.l	#'CUT_',d0	*magic number
	beq	@f

	lea	eformat(OPC),a4	*set error message
	bra	load_end
@@
	moveq.l	#0,d6
	move.w	48(a3),d6	*width
	beq	load_end

	move.l	d6,_Width
	moveq.l	#0,d4
	move.w	50(a3),d4	*height
	beq	load_end

	move.l	d4,_Height
	jbsr	_AllocateScreen
	movea.l	d0,a2		*virtual gram

	move.w	#2,-(sp)	*tail of file
	clr.l	-(sp)
	move.w	d5,-(sp)	*file handle
	DOS	__SEEK
	addq.w	#8,sp
	move.l	d0,d3		*file size
	sub.l	#HEADSIZ,d3	* - header size
	bmi	read_err

	move.l	d3,-(sp)	*file size
	DOS	__MALLOC
	addq.w	#4,sp
	tst.l	d0
	bpl	@f

	lea	ememory(OPC),a4	*set error message
	bra	load_end
@@
	move.l	d0,a5		*file buffer
	move.w	#0,-(sp)	*from head of file
	move.l	#HEADSIZ,-(sp)	*data point
	move.w	d5,-(sp)	*file handle
	DOS	__SEEK
	addq.w	#8,sp
	tst.l	d0
	bmi	read_err

	move.l	d3,-(sp)	*file size
	move.l	a5,-(sp)	*file buffer
	move.w	d5,-(sp)	*file handle
	DOS	__READ
	lea	10(sp),sp
	cmp.l	d0,d3		*read exact size ?
	beq	load_end
read_err
	lea	eread(OPC),a4	*set error message
load_end:
	tst.w	d5		*file hanle
	beq	@f		*stdin ?

	move.w	d5,-(sp)	*file handle
	DOS	__CLOSE
	addq.w	#2,sp
@@
	move.l	a4,d0		*error ?
	beq	noerr

	move.l	a2,d0		*virtual gram
	beq	@f

	move.l	d0,-(sp)
	DOS	__MFREE
	addq.w	#4,sp
@@
	move.l	a5,d0		*file buffer
	beq	@f

	move.l	d0,-(sp)
	DOS	__MFREE
	addq.w	#4,sp
@@
	move.l	a4,-(sp)	*error message
	jbsr	_error
	addq.w	#4,sp
	rts
noerr:
	tst.l	_Size
	beq	done

	movea.l	a5,a1		*file buffer
	subq.l	#1,d4
	move.w	d6,d5
	addq.w	#7,d5
	lsr.w	#3,d5		*bytes per line
	addq.w	#7,d5
	lsr.w	#3,d5		*flag size = bytes per line / 8
	subq.w	#1,d5
	movea.l	a3,a0		*bit buffer
	moveq.l	#64-1,d1	*bit size
	moveq.l	#0,d0
@@
	move.l	d0,(a0)+	*clear bit buffer
	dbra	d1,@b
ylp:
	movea.l	a3,a0		*bit buffer
	move.b	(a1)+,d0	*num of compressed bytes
	subq.b	#1,d0		*same to the previous line ?
	beq	ylpent
*not same
	move.w	d5,d3		*flag size
	lea	1(a1,d5.w),a4
xlp:
	move.b	(a1)+,d2	*flag
	moveq.l	#8-1,d1		*num of bits per byte
blp:
	clr.b	d0		*clear color
	add.b	d2,d2		*bitmap on ?
	bcc	off

	move.b	(a4)+,d0	* bits = *read++
off:
	eor.b	d0,(a0)+	* *bit buffer++ ^= bits
	dbra	d1,blp

	dbra	d3,xlp

	movea.l	a4,a1		*next line
ylpent:
	move.w	d6,d3		*width
	movea.l	a3,a0		*bit buffer
	clr.w	d0
g_xlp:
	move.b	(a0)+,d2
	moveq.l	#8-1,d1		*bit loop counter
	cmp.w	d1,d3		*rest bits >= 8 ?
	bgt	g_bitlp

	move.w	d3,d1
	subq.w	#1,d1
g_bitlp:
	add.b	d2,d2		*bitmap on ?
	scc	d0
	addq.b	#1,d0
	move.w	d0,(a2)+	*write gram
	dbra	d1,g_bitlp

	subq.w	#8,d3		*rest bits -= 8
	bgt	g_xlp

	dbra	d4,ylp
	clr.w	d4
	subq.l	#1,d4
	bpl	ylp
done:
	move.l	a5,-(sp)	*file buffer
	DOS	__MFREE
	addq.w	#4,sp

	move.l	#255,d0		*palet init (color 0, 1)
	lea	_Red,a0
	move.l	d0,(a0)
	lea	_Green,a0
	move.l	d0,(a0)
	lea	_Blue,a0
	move.l	d0,(a0)
	moveq.l	#2,d0
	move.l	d0,_MaxColorGuaranteed
	movem.l	(sp)+,d3-d6/a3-a5
	unlk	a6
	rts

eopen:
	.dc.b	'No such file',$0a,$00
ememory:
	.dc.b	'Insufficient memory',$0a,$00
eformat:
	.dc.b	'Is not cut format',$0a,$00
eread:
	.dc.b	'load error',$0a,$00

	.even
	.end
