/*
	GIF.c
*/

#include	"defs.h"
#include	"GIF.h"
#include	"gifslice.h"

extern int	loadGIFfile(picsliceinfo*);
extern int	drawGIF(picsliceinfo*);
extern void	EndOfDraw(picsliceinfo*);

void
GIFLoad()
{
	int	ret;
	picsliceinfo	psi;

	if (fp) {
		psi.fn = 0;
	} else if ((psi.fn = OPEN(File, 0)) < 0) {
		error("No such file");
	}
	if ((ret = loadGIFfile(&psi)) != PICSLICE_NORMAL) {
		if (ret == PICSLICE_NOMEMORY) {
			error("Insufficient memory");
		} else {
			error("Is not gif format");
		}
	}
	Width= psi.Width;
	Height= psi.Height;
	MaxColorGuaranteed = psi.BitPixel;

	/*	AllocateScreen()	*/
    if (Screen)	MFREE(Screen);
    if ((int)(Screen = (int16*)MALLOC(Size = Width * Height * 2)) < 0) {
		EndOfDraw(&psi);
		error("Insufficient memory");
	}

	(unsigned short*)psi.chainbuf = Screen;

	if (drawGIF(&psi) != PICSLICE_TERMINATE) {
		error("load error");
	} else {
		unsigned char	*r = psi.ColorMap;
		int	i;

		for (i = 0; i < MaxColorGuaranteed; i++) {
			Red[i]   = *r++;
			Green[i] = *r++;
			Blue[i]  = *r++;
		}

		if (OutBpp == 1) {
			InBpp = 64 + 1;
			SETBLOCK(Screen, Size / 2);
		} else {
			unsigned short	*w = Screen + Size / 2;

			r = (unsigned char*)Screen;
			i = Size / 2;
			r += i;
			while (--i >= 0)	*--w= *--r;
		}
	}
}
