*
*		GIFld.s	
*			2000/01/29 Rick
*
*	based on giftoppm.c (netpbm)

* +-------------------------------------------------------------------+ */
* | Copyright 1990, 1991, 1993, David Koblas.  (koblas@netcom.com)    | */
* |   Permission to use, copy, modify, and distribute this software   | */
* |   and its documentation for any purpose and without fee is hereby | */
* |   granted, provided that the above copyright notice appear in all | */
* |   copies and that both that copyright notice and this permission  | */
* |   notice appear in supporting documentation.  This software is    | */
* |   provided "as is" without express or implied warranty.           | */
* +-------------------------------------------------------------------+ */


RUNS_HUMAN_VERSION	equ	3
	.include	doscall.mac

DICSIZ		equ	4096*4
STACKSIZ	equ	4096
FILSIZ		equ	8192

BUFSIZ		equ	DICSIZ+STACKSIZ+FILSIZ

	.offset 0
FN:		.ds.l	1	*0
FILEBUF:	.ds.l	1	*4
FILEBUFSIZE:	.ds.l	1	*8
CURRENTBYTE:	.ds.l	1	*12
REALWIDTH:	.ds.l	1	*16
WIDTH:		.ds.l	1	*20
HEIGHT:		.ds.l	1	*24
READBUF:	.ds.l	1	*28
GETPOINT:	.ds.l	1	*32
DONE:		.ds.w	1	*36
CHAINBUF:	.ds.l	1	*38
CHAINBUFSIZE:	.ds.l	1	*42
DICTOP:		.ds.l	1	*46
ADDY:		.ds.w	1	*50
ADDADD:		.ds.l	1	*52
YPOS:		.ds.w	1	*56
BYTECOUNT:	.ds.l	1	*58
BLKREST:	.ds.w	1	*62
UNREAD:		.ds.w	1	*64
BITPIXEL:	.ds.l	1	*66
CURBIT:		.ds.w	1	*70
PASS:		.ds.w	1	*72
CLEARCODE:	.ds.w	1	*74
ENDCODE:	.ds.w	1	*76
FIRSTCODE:	.ds.w	1	*78
OLDCODE:	.ds.w	1	*80
SETCODESIZE:	.ds.w	1	*82
CODESIZE:	.ds.w	1	*84
CODEMASK:	.ds.w	1	*86
MAXCODE:	.ds.w	1	*88
MAXCODESIZE:	.ds.w	1	*90
BITBUF:		.ds.l	1	*92
COLORMAP:	.ds.b	256*3	*322

	.even
	.text

	.globl _loadGIFfile
_loadGIFfile:
	movem.l	d3/d4/d5/d6/d7/a3/a5/a6,-(sp)
	movea.l	4+8*4(sp),a5	*psi
	move.l	#FILSIZ,FILEBUFSIZE(a5)
	pea	BUFSIZ.l	* dicsiz + stacksiz + filsiz
	DOS	__MALLOC
	addq.w	#4,sp
	move.l	d0,FILEBUF(a5)
	bgt	gotmemory

	moveq.l	#102,d2		*PICSLICE_EMEMORY
	add.w	d2,d2
	bra	load_err
read_err:
	move.l	#203,d2		*PICSLICE_EREAD
	bra	load_err
gotmemory:
	movea.l	d0,a2
	move.l	a2,DICTOP(a5)
	lea.l	DICSIZ+STACKSIZ(a2),a0	*dic size + stack size
	move.l	a0,READBUF(a5)
	moveq.l	#0,d0
	move.l	d0,BYTECOUNT(a5)
	move.w	d0,DONE(a5)

	movea.l	a2,a1
	moveq.l	#13,d2
	bsr	ReadOK
	tst.l	d0
	ble	read_err

	move.l	(a2)+,d0
	cmpi.l	#'GIF8',d0
	bne	notgif
	move.w	(a2)+,d0
	cmpi.w	#'7a',d0
	beq	@f

	cmpi.w	#'9a',d0
	beq	@f
notgif:
	moveq.l	#101,d2		*PICSLICE_EFORMAT
	add.w	d2,d2
	bra	load_err
@@
	move.b	4(a2),d0
	moveq.l	#7,d1
	and.b	d0,d1
	moveq.l	#2,d2
	asl.l	d1,d2
	move.l	d2,BITPIXEL(a5)
	tst.b	d0
	bpl	@f

	lea.l	COLORMAP(a5),a2
	move.l	d2,d0
	bsr	ReadColorMap
	tst.b	d0
	beq	read_err
@@
	bsr	nextGIF
	cmpi.l	#200,d2		*PICSLICE_NORMAL
	bne	load_err

	moveq.l	#100,d2		*PICSLICE_NORMAL
	add.w	d2,d2
	bra	@f
load_err:
	move.l	a5,-(sp)	*psi
	jbsr	_EndOfDraw
	addq.w	#4,sp
@@
	move.l	d2,d0		*return code
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a5/a6
	rts
	.even

nextGIF:
	movea.l	DICTOP(a5),a3
chk_ext:
	movea.l	a3,a1
	moveq.l	#1,d2
	bsr	ReadOK
	tst.l	d0
	ble	eread

	move.b	(a3),d0
	cmpi.b	#';',d0
	bne	@f

	move.l	#201,d2		*PICSLICE_TERMINATE
	bra	end_nextGIF
@@
	cmpi.b	#'!',d0
	bne	notextention

	moveq.l	#1,d2
	bsr	ReadOK
	tst.l	d0
	ble	eread
DoExtension:
	bsr	GetDataBlock
	tst.w	d0
	beq	chk_ext
	bgt	DoExtension
	bra	eread

notextention:
	cmp.b	#',',d0
	bne	chk_ext

	moveq.l	#9,d2
	movea.l	a3,a1
	bsr	ReadOK
	tst.l	d0
	ble	eread

	move.b	8(a3),d0
	bpl	@f
*use local color map
	moveq.l	#7,d1
	and.b	d0,d1
	addq.w	#1,d1
	moveq.l	#1,d0
	lsl.w	d1,d0
	lea.l	COLORMAP(a5),a2	*local color map (overwrite)
	bsr	ReadColorMap
	tst.b	d0
	beq	eread
@@
	moveq.l	#3,d0
	moveq.l	#64,d1
	and.b	8(a3),d1
	bne	@f

	moveq.l	#-1,d0
@@
	move.w	d0,PASS(a5)	*interlace

	moveq.l	#0,d0
	move.w	d0,YPOS(a5)
	move.w	#8,ADDY(a5)
	move.w	6(a3),d0
	ror.w	#8,d0		*little endian
	move.l	d0,HEIGHT(a5)	*height
	move.w	4(a3),d0
	ror.w	#8,d0		*little endian
	move.l	d0,WIDTH(a5)	*len (width)
	move.l	d0,d1
	lsl.l	#3,d1
	sub.l	d0,d1
	move.l	d1,ADDADD(a5)
*ReadImage:
	tst.w	BYTECOUNT+2(a5)
	bgt	@f

	bsr	nextbuf
	tst.l	d0
	ble	eread
@@
	movea.l	CURRENTBYTE(a5),a6
	moveq.l	#0,d0
	move.b	(a6)+,d0	*setcodesize
	move.l	a6,CURRENTBYTE(a5)
	subq.w	#1,BYTECOUNT+2(a5)

	move.w	d0,SETCODESIZE(a5)
	addq.w	#2,d0
	moveq.l	#1,d4
	lsl.w	d0,d4		*clearcode = 1 << SETCODESIZE

	move.w	d4,d0
	addq.w	#1*4,d0
	move.w	d0,ENDCODE(a5)	*endcode = clearcode + 1

	bsr	initdic

	moveq.l	#0,d5		*curbit = 0
	move.w	d5,d6		*blkrest = 0
	move.w	d5,UNREAD(a5)
firstcodelp:
	bsr	GetCode
	cmp.w	d1,d4		*code = clearcode ?
	beq	firstcodelp

	move.w	d1,d0
	bmi	eread

	move.l	a6,GETPOINT(a5)
	move.w	d4,CLEARCODE(a5)
	move.w	d5,CURBIT(a5)
	move.w	d6,BLKREST(a5)
	move.l	d7,BITBUF(a5)
	move.w	d1,OLDCODE(a5)
	lsr.w	#2,d1
	move.w	d1,FIRSTCODE(a5)
	bra	normalend
eread:
	move.l	#203,d2		*PICSLICE_EREAD
	bra	end_nextGIF
normalend:
	moveq.l	#100,d2		*PICSLICE_NORMAL
	add.w	d2,d2
end_nextGIF:
	rts

	.even
ReadColorMap:
				*arg : d0 = num of color
				*      a2 = colormap address
				*destroy : d0-d2,a0-a1
	move.l	d0,d3		*BitPixel

	add.w	d0,d0
	add.w	d3,d0
	move.l	d0,d2		*num of byte to read RGB

	movea.l	a2,a1
	bsr	ReadOK
	tst.l	d0
	ble	end_readcolor

	lea.l	_Palette,a1
	bra	readcolor_ent
readcolor_lp:
	move.b	1(a2),d0	*G
	lsl.w	#5,d0
	move.b	(a2),d0		*R
	lsr.w	#3,d0
	lsl.w	#5,d0
	move.b	2(a2),d1	*B
	lsr.b	#3,d1
	or.b	d1,d0
*	add.w	d0,d0		*comment for coerce
	move.w	d0,(a1)+	*ColorPalet(0GGGGGRR_RRRBBBBB)
readcolor_ent:
	dbra	d3,readcolor_lp

	moveq.l	#1,d0
end_readcolor:
	rts

	.even
ReadOK:
	moveq.l	#0,d0
	move.w	BYTECOUNT+2(a5),d1
	bmi	end_readok

	movea.l	CURRENTBYTE(a5),a0
	bra	cp_ent
cp_lp:
	dbra	d1,@f

	bsr	nextbuf
	move.l	d0,d1		*bytecount
	ble	end_readok

	subq.w	#1,d1
@@
	move.b	(a0)+,(a1)+
cp_ent:
	dbra	d2,cp_lp

	moveq.l	#1,d0
end_readok:
	move.w	d1,BYTECOUNT+2(a5)
	move.l	a0,CURRENTBYTE(a5)
	rts

	.even
GetDataBlock:
				*arg : a1 = buf
	movea.l	CURRENTBYTE(a5),a0
	move.w	BYTECOUNT+2(a5),d1
	bmi	cantfilbuf
	dbra	d1,@f

	bsr	nextbuf
	move.l	d0,d1		*bytecount
	subq.w	#1,d1
	bmi	cantfilbuf
@@
	moveq.l	#0,d2
	move.b	(a0)+,d2	*blksize
	move.w	d2,d0
	swap.w	d2
	move.w	d0,d2
	bra	skip_ent
skip_lp:
	sub.w	d1,d2
	bsr	nextbuf
	move.l	d0,d1
	bgt	skip_ent
cantfilbuf:
	moveq.l	#-1,d0
	rts
skip_ent:
	cmp.w	d1,d2
	bgt	skip_lp

	sub.w	d2,d1
	move.w	d1,BYTECOUNT+2(a5)
	lea.l	(a0,d2.w),a0
	move.l	a0,CURRENTBYTE(a5)
	swap.w	d2
	move.w	d2,d0
	rts

	.even
nextbuf:
	move.b	DONE(a5),d0
	beq	@f
	moveq.l	#-1,d0
	rts
@@
	movea.l	READBUF(a5),a0
	move.l	a0,CURRENTBYTE(a5)
	move.l	FILEBUFSIZE(a5),d1
	move.l	d1,-(sp)	*filebufsize
	move.l	a0,-(sp)	*readbuf
	move.w	FN+2(a5),-(sp)	*file handle
	DOS	__READ
	lea.l	10(sp),sp
	move.l	d0,BYTECOUNT(a5)
	cmp.l	d0,d1
	sne	d1
	move.b	d1,DONE(a5)
	rts

	.even
nextblk:
	move.w	BYTECOUNT+2(a5),d0
	bgt	@f
	bsr	nextbuf
	move.l	d0,d6
	bgt	@f
	rts
@@
	moveq.l	#0,d6
	move.w	UNREAD(a5),d6
	bne	gotblksiz

	subq.w	#1,d0
	move.w	d0,BYTECOUNT+2(a5)
	movea.l	CURRENTBYTE(a5),a6	*getpoint = currentbyte
	move.b	(a6)+,d6		*blksize
	move.l	a6,CURRENTBYTE(a5)
	tst.w	d6
	bne	@f
	moveq.l	#-1,d6
	rts
@@
	tst.w	d0
	bgt	gotblksiz
	bsr	nextbuf
	tst.l	d0
	bgt	gotblksiz
	move.l	d0,d6
	rts
gotblksiz:
	movea.l	CURRENTBYTE(a5),a6
	cmp.w	d0,d6
	ble	@f
	sub.w	d0,d6
	move.w	d6,UNREAD(a5)
	move.w	d0,d6
	bra	end_nextblk
@@
	clr.w	UNREAD(a5)
	add.l	d6,CURRENTBYTE(a5)
end_nextblk:
	sub.w	d6,BYTECOUNT+2(a5)
	rts

GetCode:
	move.w	CODESIZE(a5),d0
	cmp.w	d0,d5		*codesize <= curbit ?
	bge	cutbits

	moveq.l	#16,d2		*getbits = 16
	ror.l	d5,d7		*bitbuf >> curbit
	subq.w	#1,d6		*lastbyte == 0 ?
	bgt	addword
	beq	addbyte
*blkbuf is empty
	bsr	nextblk
	subq.w	#1,d6
	bpl	@f
err_getcode:
	moveq.l	#-1,d1		*errcode
	rts
addbyte:
	move.b	(a6),d7		*bitbuf.low = *getpoint
	bsr	nextblk
	move.b	d7,-(a6)	* *--getpoint = bitbuf.low
	tst.w	d6
@@
	bgt	@f
	move.w	d5,d1
	moveq.l	#8,d2
	add.w	d2,d1
	cmp.w	CODESIZE(a5),d1	*codesize <= curbit + 8 ?
	blt	err_getcode
@@
	move.w	CODESIZE(a5),d0
addword:
	movep.w	1(a6),d7	*bitbuf.high = *(getpoint + 1)
	move.b	(a6),d7		*bitbuf.low = *getpoint
	addq.w	#2,a6		*getpoint += 2
	subq.w	#1,d6		*lastbyte--
	rol.l	d5,d7		*bitbuf << curbit
	add.w	d2,d5		*curbit += getbits
cutbits:
	move.w	CODEMASK(a5),d1
	and.w	d7,d1		*code = bitbuf & codemask
	lsr.l	d0,d7		*bitbuf >> codesize
	sub.w	d0,d5		*curbit -= codesize

	add.w	d1,d1
	add.w	d1,d1		*code *= 4
	rts

	.even
	.globl	_drawGIF
_drawGIF:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	movea.l	4+9*4(sp),a5	*psi
	movea.l	GETPOINT(a5),a6
	movea.l	DICTOP(a5),a4
	movea.l	READBUF(a5),a3
	movea.l CHAINBUF(a5),a2
	move.l	BITBUF(a5),d7
	move.w	BLKREST(a5),d6
	move.w	CURBIT(a5),d5
	move.w	CLEARCODE(a5),d4
	move.b	FIRSTCODE+1(a5),-(a3)
ylp:
	move.w	WIDTH+2(a5),d3
xlp:
	move.l	READBUF(a5),d1
	sub.l	a3,d1		*stack length
	beq	LWZReadByte

	cmp.w	d1,d3
	bgt	allflush
	subq.w	#1,d3
flushlp:
	move.b	(a3)+,(a2)+
	dbra	d3,flushlp

	bra	xlpend
allflush:
	sub.w	d1,d3
	subq.w	#1,d1
allflushlp:
	move.b	(a3)+,(a2)+
	dbra	d1,allflushlp
LWZReadByte:
	bsr	GetCode
	blt	ylpbreak	*code < 0 ?

	cmp.w	d4,d1		*clear_code == code ?
	beq	dicclr

	cmp.w	ENDCODE(a5),d1	*end_code == code ?
	beq	terminate

	move.w	d1,d2		*incode = code
	lea.l	MAXCODE(a5),a1
	cmp.w	(a1),d1		*maxcode > code ?
	blt	back_ent

	move.b	FIRSTCODE+1(a5),-(a3)	* *--sp = firstcode
	move.w	OLDCODE(a5),d1	*code = oldcode
	bra	back_ent
back_lp:
	move.l	(a4,d1.w),d0	*c = dic[code]
	move.b	d0,-(a3)	* *--sp = suffix[c]
	swap.w	d0
	cmp.w	d0,d1		*prefix[c] == c ?
	beq	ylpbreak	*circular table entry

	move.w	d0,d1		*code = c
back_ent:
	cmp.w	d4,d1		*clearcode <= code ?
	bge	back_lp

	move.w	2(a4,d1.w),d0	*c = suffix[code]
	move.w	d0,FIRSTCODE(a5)	*firstcode = c
	move.b	d0,-(a3)	*--sp = c

	move.w	(a1),d1		*maxcode
	cmpi.w	#4096*4,d1	*4096 <= maxcode ?
	bcc	xlp_ent

	lea.l	(a4,d1.w),a0	*dic[maxcode]
	move.w	OLDCODE(a5),(a0)+	*prefix[maxcode] = oldcode
	move.w	d0,(a0)		*suffix[maxcode] = firstcode
	addq.w	#4,d1		*++maxcode
	move.w	d1,(a1)+	* = maxcode
	move.w	(a1),d0		*maxcodesize
	cmp.w	d1,d0		*maxcode < maxcodesize ?
	bhi	xlp_ent

	cmpi.w	#4096*4,d0	*4096 <= maxcodesize ?
	bcc	xlp_ent

	add.w	d0,(a1)		*maxcodesize *= 2
	subq.w	#6,a1
	addq.w	#1,(a1)+	*++codesize
	move.w	(a1),d0		*codemask
	add.w	d0,d0
	addq.w	#1,d0
	move.w	d0,(a1)		*new codemask = (codemask << 1) + 1
xlp_ent:
	move.w	d2,OLDCODE(a5)	*oldcode = incode
	bra	xlp
xlpend:
	lea.l	PASS(a5),a0
	move.w	(a0),d2		*pass
	bmi	notinterlace

	adda.l	ADDADD(a5),a2
	move.w	ADDY(a5),d0
	add.w	d0,YPOS(a5)
	move.w	HEIGHT+2(a5),d1
	cmp.w	YPOS(a5),d1
	bgt	ylp

	movea.l	CHAINBUF(a5),a2
	move.l	WIDTH(a5),d0
	subq.w	#1,d2		*pass-
	move.w	d2,(a0)
	bmi	terminate	*pass0

	beq	pass1		*pass1

	subq.w	#2,d2
	bmi	pass2		*2

	bne	ylpbreak	*3<pass
pass3:
	move.w	#4,YPOS(a5)	*ypos = 4
	lsl.l	#2,d0		*vgram restart = 4
	adda.l	d0,a2
	bra	ylp
pass1:
				*vgram restart = 1
	move.l	d0,ADDADD(a5)
	moveq.l	#1,d1		*n = 1
	bra	@f
pass2:
	move.l	d0,d1
	add.w	d0,d0		*vgram restart = 2
	add.w	d0,d1
	move.l	d1,ADDADD(a5)
	moveq.l	#2,d1		*n = 2
@@
	move.w	d1,YPOS(a5)	*ypos = n
	add.w	d1,d1
	move.w	d1,ADDY(a5)	*addy = n * 2
	adda.l	d0,a2
	bra	ylp
notinterlace:
	addq.w	#1,YPOS(a5)
	move.w	HEIGHT+2(a5),d1
	cmp.w	YPOS(a5),d1
	bgt	ylp
terminate:
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	endop

dicclr:
	bsr	initdic
	movea.l	READBUF(a5),a3	*sp = stacktop
	bsr	GetCode
	move.w	d1,OLDCODE(a5)
	lsr.w	#2,d1
	move.w	d1,FIRSTCODE(a5)
	move.b	d1,-(a3)
	bra	xlp

ylpbreak:
	move.l	#203,d0		*PICSLICE_EREAD
endop:
	move.l	d0,d3
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.even
initdic:
	movea.l	DICTOP(a5),a0	*DICTOP
	move.w	d4,d2		*clearcode
	lsr.w	#2,d2
	subq.w	#1,d2		*loop counter = clearcode / 4 - 1
	moveq.l	#0,d1
dicclrlp1:
	move.l	d1,(a0)+
	addq.w	#1,d1
	dbra	d2,dicclrlp1

	move.w	#4096,d2
	sub.w	d1,d2
	moveq.l	#0,d0
	bra	dicclrent2
dicclrlp2:
	move.l	d0,(a0)+
dicclrent2:
	dbra	d2,dicclrlp2

	lea.l	SETCODESIZE(a5),a0
	move.w	(a0)+,d0
	addq.w	#1,d0
	move.w	d0,(a0)+	*codesize = setcodesize + 1

	moveq.l	#1,d1
	lsl.w	d0,d1
	subq.w	#1,d1
	move.w	d1,(a0)+	*codemask = (1 << codesize) - 1

	move.w	d4,d0
	addq.w	#2*4,d0
	move.w	d0,(a0)+	*maxcode = clearcode + 2

	move.w	d4,d0
	add.w	d0,d0
	move.w	d0,(a0)		*maxcodesize = clearcode * 2

	rts

	.even
	.end
