* PIC loader for coerce X68K
*
* original PICSLICE.C by A.TAN
* modified 1999/11/09 by Rick

RUNS_HUMAN_VERSION	equ	3
	.include doscall.mac

PS_TERMINATE	equ	201
PS_EREAD	equ	203
PS_NOMEMORY	equ	205

WORKSIZ	equ	28

	.offset -WORKSIZ

FH:		.ds.l	1	*0
FILBUF:		.ds.l	1	*4
FILSIZ:		.ds.l	1	*8
BITCT:		.ds.w	1	*12
BITBUF:		.ds.w	1	*14
RWIDTH:		.ds.l	1	*16
WIDTH:		.ds.l	1	*20
HEIGHT:		.ds.l	1	*24
CURWORD:	.ds.l	1	*28
ADR		.ds.l	1	*32
WORDCT:		.ds.w	1	*36
VBUF:		.ds.l	1	*38
VBUFSIZ:	.ds.l	1	*42
ERROR:		.ds.w	1	*46
LENGTH:		.ds.l	1	*48
CURCOL:		.ds.w	1	*52
COLOR:		.ds.w	1	*54
COL:		.ds.w	128	*56
TBL:		.ds.b	128*2	*312

	.text

READBIT1	macro
	local	n0,e0

	dbra	d7,e0
	subq.w	#1,WORDCT(a0)
	bpl	n0
	bsr	readbuf
n0
	moveq.l	#15,d7
	moveq.l	#0,d6
	move.w	(a3)+,d6
e0
	add.w	d6,d6
	scc	d0
	addq.b	#1,d0

	endm

READBIT7	macro
	local	n7,e7

	moveq.l	#0,d1
	cmp.w	d7,d2
	ble	e7

	sub.w	d7,d2
	move.w	d6,d1
	lsl.l	d7,d1
	subq.w	#1,WORDCT(a0)
	bpl	n7
	bsr	readbuf
n7
	moveq.l	#0,d6
	move.w	(a3)+,d6
	moveq.l	#16,d7
e7
	sub.w	d2,d7
	move.w	d6,d1
	lsl.l	d2,d1
	move.w	d1,d6
	clr.w	d1
	swap.w	d1
	move.l	d1,d0

	endm

READBIT	macro
	local	n1,n2,e

	moveq.l	#0,d1
	cmp.w	d7,d2
	ble	e

	sub.w	d7,d2
	move.w	d6,d1
	rol.w	d7,d1
	subq.w	#1,WORDCT(a0)
	bpl	n1
	bsr	readbuf
n1
	moveq.l	#0,d6
	move.w	(a3)+,d6
	moveq.l	#16,d7
	cmp.w	d7,d2
	ble	e

	sub.w	d7,d2
	swap.w	d1
	move.w	d6,d1
	subq.w	#1,WORDCT(a0)
	bpl	n2
	bsr	readbuf
n2
	moveq.l	#0,d6
	move.w	(a3)+,d6
	moveq.l	#16,d7
e
	sub.w	d2,d7
	lsl.l	d2,d1
	lsl.l	d2,d6
	swap.w	d6
	or.w	d6,d1
	clr.w	d6
	swap.w	d6
	move.l	d1,d0

	endm

squarecom:
	.dc.b	"/XSS/"

	.even
	.globl	_loadPICfile
_loadPICfile:
	movem.l	d3/d6/d7/a3,-(sp)
	move.l	4*4+4(sp),a0	*psi
	lea	WORKSIZ(a0),a0
	move.l	#16384,d0
	move.l	d0,FILSIZ(a0)	*filebufsize
	move.l	d0,-(sp)
	DOS	__MALLOC
	addq.w	#4,sp
	tst.l	d0
	bgt	@f

	move.l	#PS_NOMEMORY,d0
	bra	openerr
@@
	move.l	d0,FILBUF(a0)
	move.l	d0,CURWORD(a0)
	moveq.l	#0,d2
	move.l	d2,d7		*bitcount
	move.l	d2,WORDCT(a0)
	move.w	d2,ERROR(a0)

	bsr	getc		*init
	bsr	getc
	cmpi.b	#'P',d0
	bne	eformat

	bsr	getc
	cmpi.b	#'I',d0
	bne	eformat

	bsr	getc
	cmpi.b	#'C',d0
	bne	eformat

	lea	squarecom(OPC),a2
nomatch:
	moveq.l	#0,d2
comment_lp:
	bsr	getc
	cmpi.b	#$1a,d0
	beq	skip_lp

	cmpi.w	#5,d2
	bge	comment_lp

	cmp.b	(a2,d2.w),d0
	bne	nomatch

	addq.w	#1,d2
	bra	comment_lp
skip_lp:
	tst.l	_NoExpand
	bpl	adjust_checked

	moveq.l	#0,d0
	cmpi.w	#5,d2
	sne	d0
	addq.b	#1,d0
	move.l	d0,_NoExpand
adjust_checked:
	bsr	getc
	tst.b	d0
	bne	skip_lp

	bsr	getc
	tst.b	d0
	bne	eformat

	bsr	getc
	tst.b	d0
	bne	eformat

	bsr	getc
	tst.b	d0
	bne	eformat

	bsr	getc
	cmpi.b	#15,d0		*pixel/bit (original PIC)
	beq	getsize
eformat:
	moveq.l	#101,d0
	add.w	d0,d0		*PICSLICE_EFORMAT
	bra	openerr
getsize:
	bsr	getc
	moveq.l	#0,d3
	move.b	d0,d3
	lsl.w	#8,d3
	bsr	getc
	move.b	d0,d3
	move.l	d3,WIDTH(a0)

	add.l	d3,d3
	move.l	d3,RWIDTH(a0)

	bsr	getc
	moveq.l	#0,d2
	move.b	d0,d2
	lsl.w	#8,d2
	bsr	getc
	move.b	d0,d2
	move.l	d2,HEIGHT(a0)

	moveq.l	#0,d1
	move.w	d1,CURCOL(a0)	*ݐFindex
	move.w	d1,COLOR(a0)	*Ō̐F
	lea	COL(a0),a1
	lea	TBL(a0),a2
	moveq.l	#128-1,d2
ctbl_init:
	clr.w	(a1)+		*col
	subq.w	#2,d1
	move.b	d1,1(a2)	*next
	addq.w	#4,d1
	move.b	d1,(a2)		*prev
	addq.w	#2,a2
	dbra	d2,ctbl_init

	moveq.l	#0,d2
firstlen:
	addq.w	#1,d2
	READBIT1
	bne	firstlen

	moveq.l	#1,d3
	asl.l	d2,d3
	READBIT
	move.l	d0,a2
	lea	-2(a2,d3.l),a2
	move.l	a2,LENGTH(a0)
	tst.w	ERROR(a0)
	beq	normal

	move.l	#PS_EREAD,d0
	bra	openerr
normal:
	move.w	d6,BITBUF(a0)
	move.w	d7,BITCT(a0)
	move.l	a3,CURWORD(a0)
	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
	bra	load_end
openerr:
	move.l	d0,d3
	pea	-WORKSIZ(a0)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
load_end:
	movem.l	(sp)+,d3/d6/d7/a3
	rts

	.even
	.globl _drawPIC
_drawPIC:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	9*4+4(sp),a0
	lea	WORKSIZ(a0),a0
	move.l	a0,-(sp)
	bsr	vgclr
	addq.w	#4,sp

	move.w	BITBUF(a0),d6	*bit buffer
	move.w	BITCT(a0),d7	*bitcount
	movea.l	CURWORD(a0),a3
	movea.l	RWIDTH(a0),a6	*GRAMł̒
	movea.l	WIDTH(a0),a4	*Wł̉
	move.l	VBUF(a0),ADR(a0)	*frame
	movea.l	LENGTH(a0),a5	*runlength A̒
	moveq.l	#0,d5		*݂̏cʒu
	bra	entry
linedraw:
	suba.l	a4,a5		*current runlength -= width
	movea.l	ADR(a0),a2	*O̍s̍[
	move.w	COLOR(a0),d2	*O̐F
	move.w	a4,d1		*(W)
	bra	draw_ent
draw_lp:
	move.w	(a2),d0		*Fǂ
	bmi	@f		*}[N

	move.w	d0,d2		*hFɂ
@@
	move.w	d2,(a2)+	*h
draw_ent:
	dbra	d1,draw_lp	*E[܂

	move.w	d2,COLOR(a0)	*Ō̐FL^
	move.l	a2,ADR(a0)	*frame += realwidth ̍s
	addq.w	#1,d5		* yW++
	cmp.w	HEIGHT+2(a0),d5	*܂ŒB
	beq	done
entry:
	cmpa.l	a4,a5		*ʂ̕𒴂邩
	bge	linedraw

*readColor
	moveq.l	#0,d3
	moveq.l	#8,d2
	READBIT7
	tst.b	d0
	bmi	cache
				*LbVɂȂF
	moveq.l	#8,d2
	move.b	d0,-(sp)
	READBIT7
	move.w	(sp)+,d2
	move.b	d0,d2
	move.w	CURCOL(a0),d0	*ݐFindex
	lea	TBL(a0),a1
	move.b	(a1,d0.w),d3	*prev[curcol] LbV̈Ԍ
	move.w	d3,CURCOL(a0)
	move.w	d2,COL(a0,d3.w)	*LbVɓo^
	move.w	d2,d3		*`F
	bra	cwrite
cache:
	add.b	d0,d0		*idx
	move.w	CURCOL(a0),d1	*ݐFindex (cc)
	cmp.w	d1,d0		*ݐFƓ?
	beq	same

	lea	TBL(a0),a1	*LbVł̌
	lea	(a1,d0.w),a2	*prev[idx]
	move.b	(a2)+,d2	*prev[idx]
	move.b	(a2),d3		*next[idx]
	move.b	d1,(a2)		*cc->next[idx]
	move.b	d2,(a1,d3.w)	*prev[idx]->prev[next[idx]]
	move.b	d3,1(a1,d2.w)	*next[idx]->next[prev[idx]]
	move.b	(a1,d1.w),d2	*prev[cc]
	move.b	d2,-(a2)	*prev[cc]->prev[idx]
	move.b	d0,1(a1,d2.w)	*idx->next[prev[cc]]
	move.b	d0,(a1,d1.w)	*idx->prev[cc]

	move.w	d0,CURCOL(a0)	*idx->cc
same:
	move.w	COL(a0,d0.w),d3	*color[idx]
cwrite:
	tst.w	ERROR(a0)	*readerror
	bne	eread

	move.l	a5,d0		*AAhXɊZ
	add.w	d0,d0
	movea.l	ADR(a0),a2	*frame
	move.w	d3,(a2,d0.w)	*ω_u
	READBIT1
	beq	getlen		*cɐL΂?

*expandChain
	move.w	HEIGHT+2(a0),d4
	sub.w	d5,d4		*height - currenty
	subq.w	#1,d4		*c̎c̒
	swap.w	d5
	move.w	a5,d5
chain:
	moveq.l	#2,d2
	READBIT7
	bne	@f		*11 E, 10 , 01 

	READBIT1
	beq	endchain	*000 ܂

	READBIT1
	beq	@f		*0010 

	moveq.l	#4,d0		*0011 EE
@@
	subq.w	#2,d0
	add.w	d0,d5		*ړ
	blt	over		*ɂ͂ݏo ?

	cmp.w	a4,d5		*Eɂ͂ݏo ?
	dbge	d4,mark
over:
	moveq.l	#2,d2
	READBIT7
	bne	over		*11 10 01 ǂ݂Ƃ΂

	READBIT1
	beq	endchain	*000 A܂

	READBIT1
	bra	over		*001x ܂ǂ݂Ƃ΂
mark:
	move.w	d5,d0		*ړ
	add.w	d0,d0		*AhXZ
	adda.l	a6,a2		*̍s
	move.w	d3,(a2,d0.w)	*}[N
	bra	chain		*̘A
endchain:
	swap.w	d5
getlen:
	moveq.l	#0,d2		*̒
@@
	addq.w	#1,d2
	READBIT1
	bne	@b

	moveq.l	#1,d3
	asl.l	d2,d3
	READBIT
	adda.l	d0,a5
	lea	-1(a5,d3.l),a5	*runlength
	tst.w	ERROR(a0)	*readerror ?
	beq	entry
eread:
	move.l	#PS_EREAD,d0
	bra	endop
done:
	move.l	#PS_TERMINATE,d0
endop:
	move.l	d0,d7
	pea	-WORKSIZ(a0)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.even
readbuf:
	move.l	FILSIZ(a0),-(sp)
	move.l	FILBUF(a0),-(sp)
	move.w	FH+2(a0),-(sp)
	DOS	__READ
	lea	10(sp),sp
	bmi	@f

	subq.w	#2,d0
	lsr.w	d0
	move.w	d0,WORDCT(a0)
	movea.l	FILBUF(a0),a3
	rts
@@
	moveq.l	#1,d0
	move.w	d0,ERROR(a0)
	rts

	.even
getc:
	moveq.l	#0,d0
	lsl.l	#8,d6
	swap.w	d6
	move.b	d6,d0
	clr.w	d6
	swap.w	d6
	subq.w	#8,d7
	ble	fillword

	rts
fillword:
	subq.w	#1,WORDCT(a0)
	bpl	exist_word

	bsr	readbuf
exist_word:
	moveq.l	#0,d6
	move.w	(a3)+,d6
	moveq.l	#16,d7
	rts

	.even
vgclr:				*virtual gram clr
	move.l	4(sp),a1	*psi
	movem.l	d3-d7,-(sp)
	move.l	WIDTH(a1),d0	*width
	move.l	HEIGHT(a1),d1	*height
	movea.l	VBUF(a1),a1	*buf
	mulu	d1,d0		*size
	moveq.l	#0,d1
	move.b	d0,d1		*size % 256
	move.l	d0,d2
	lsr.l	#8,d0		*size / 256
	add.l	d2,d2		*bufsize
	adda.l	d2,a1

	moveq.l	#-1,d2
	movea.l	a1,a2
	bra	@f
clr2:
	move.w	d2,(a2)+
@@
	dbra	d1,clr2

	move.l	d2,d1
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.l	d2,d7
	movea.l	d2,a2
	bra	@f
clr1:
	.rept 16
	movem.l	d1-d7/a2,-(a1)
	.endm
@@
	dbra	d0,clr1
	clr.w	d0
	subq.l	#1,d0
	bpl	clr1

	movem.l	(sp)+,d3-d7
	rts

	.even
	.end
