*	TTLLoad.s

RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include	doscall.mac

HEADSIZ	equ	68
LF	equ	$0a
NULL	equ	$00

	.text

	.even
	.globl	_TTLLoad
_TTLLoad:
	link	a6,#-HEADSIZ	*header size
	movem.l	d3-d7/a3-a5,-(sp)

	suba.l	a4,a4		*error message pointer init
	movea.l	a4,a2		*virtual gram pointer init
	movea.l	a4,a5		*file buffer pointer init
	moveq.l	#0,d5		*file handle init
	tst.l	_fp
	bne	@f		*stdin ?

	clr.w	-(sp)		*read mode
	move.l	_File,-(sp)	*file name
	DOS	__OPEN
	addq.w	#6,sp
	move.l	d0,d5		*file handle
	bpl	@f

	lea	eopen(OPC),a4	*set error message
	bra	load_end
@@
	moveq.l	#HEADSIZ,d3
	move.l	d3,-(sp)	*read size
	lea	-HEADSIZ(a6),a3
	move.l	a3,-(sp)	*read buf
	move.w	d5,-(sp)	*file  handle
	DOS	__READ
	lea	10(sp),sp
	cmp.l	d0,d3		*read exact size ?
	bne	read_err

	move.w	(a3),d0		*magic number / attribute
	beq	@f

	lea	eformat(OPC),a4	*set error message
	bra	load_end
@@
	moveq.l	#0,d6
	move.w	64(a3),d6	*width
	beq	load_end

	move.l	d6,_Width
	moveq.l	#0,d4
	move.w	66(a3),d4	*height
	beq	load_end

	move.l	d4,_Height
	jbsr	_AllocateScreen
	movea.l	d0,a2		*virtual gram

	move.w	#2,-(sp)	*tail of file
	clr.l	-(sp)		*offset
	move.w	d5,-(sp)	*file handle
	DOS	__SEEK
	addq.w	#8,sp
	move.l	d0,d3		*file size
	sub.l	#HEADSIZ,d3
	bmi	read_err	*illegal size

	move.l	d3,-(sp)
	DOS	__MALLOC
	addq.w	#4,sp
	tst.l	d0		*file buffer
	bpl	@f

	lea	ememory(OPC),a4	*set error message
	bra	load_end
@@
	move.l	d0,a5		*file buffer
	move.w	#0,-(sp)	*head of file
	move.l	#HEADSIZ,-(sp)
	move.w	d5,-(sp)	*file handle
	DOS	__SEEK
	addq.w	#8,sp
	tst.l	d0
	bmi	read_err

	move.l	d3,-(sp)	*file size
	move.l	a5,-(sp)	*file buffer
	move.w	d5,-(sp)	*file handle
	DOS	__READ
	lea	10(sp),sp
	cmp.l	d0,d3
	beq	load_end
read_err
	lea	eread(OPC),a4	*set error message
load_end:
	tst.w	d5		*stdin ?
	beq	@f

	move.w	d5,-(sp)	*file handle
	DOS	__CLOSE
	addq.w	#2,sp
@@
	move.l	a4,d0		*error ?
	beq	noerr

	move.l	a2,d0		*virtual gram
	beq	@f

	move.l	d0,-(sp)
	DOS	__MFREE
	addq.w	#4,sp
@@
	move.l	a5,d0		*file buffer
	beq	@f

	move.l	d0,-(sp)
	DOS	__MFREE
	addq.w	#4,sp
@@
	move.l	a4,-(sp)	*error message
	jbsr	_error
	addq.w	#4,sp
	rts
noerr:
	tst.l	_Size
	beq	done

	move.b	3(a3),d0	*display plane
	cmpi.b	#4,d0		*plane 2 ?
	bne	plane3

	move.w	4(a3),d2	*color of plane 2 (15bit)
	lsr.w	#1,d2
	bra	resolve
plane3:
	cmpi.b	#8,d0		*plane 3 ?
	bne	other

	move.w	6(a3),d2	*color of plane 3 (15bit)
	lsr.w	#1,d2
	bra	resolve
other:
	move.w	#$7fff,d2	*color init in white
resolve:
	moveq.l	#7,d0
	and.b	d2,d0
	move.b	d2,d1
	lsl.b	#3,d1
	or.b	d1,d0
	lea	_Blue,a0
	move.l	d0,(a0)		*blue (24bit color)
	lsr.w	#5,d2
	moveq.l	#7,d0
	and.b	d2,d0
	move.b	d2,d1
	lsl.b	#3,d1
	or.b	d1,d0
	lea	_Red,a0		*red (24bit color)
	move.l	d0,(a0)
	lsr.w	#5,d2
	moveq.l	#7,d0
	and.b	d2,d0
	lsl.b	#3,d2
	or.b	d2,d0
	lea	_Green,a0	*green (24bit color)
	move.l	d0,(a0)

	subq.l	#1,d4
	clr.w	d0
ylp:
	move.w	d6,d3
xlp:
	move.b	(a5)+,d2
	moveq.l	#8-1,d1		*bit loop counter
	cmp.w	d1,d3		*rest bits >= 8 ?
	bgt	bitlp

	move.w	d3,d1
	subq.w	#1,d1
bitlp:
	add.b	d2,d2		*left shift bit buffer
	scc	d0		*bitmap on ?
	addq.b	#1,d0
	move.w	d0,(a2)+	*write to gram
	dbra	d1,bitlp

	subq.w	#8,d3		*rest bits -= 8
	bgt	xlp
ylpent:
	dbra	d4,ylp
	clr.w	d4
	subq.l	#1,d4
	bpl	ylp
done:
	move.l	a5,-(sp)	*file buffer
	DOS	__MFREE
	addq.w	#4,sp
	moveq.l	#2,d0		*max color
	move.l	d0,_MaxColorGuaranteed
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

eopen:
	.dc.b	'No such file',LF,NULL
ememory:
	.dc.b	'Insufficient memory',LF,NULL
eformat:
	.dc.b	'Is not ttl format',LF,NULL
eread:
	.dc.b	'load error',LF,NULL

	.even
	.end
