*	TTL save

RUNS_HUMAN_VERSION	equ	3
	.cpu	68000
	.include	doscall.mac

HEADSIZ	equ	68

	.even
	.text

	.globl	_TTLSave
_TTLSave:
	link	a6,#-HEADSIZ	*header buf
	movem.l	d3/d4/d5/d6/d7/a3/a4,-(sp)
	lea	-HEADSIZ(a6),a3	*header address
	suba.l	a4,a4		*error message init
	moveq.l	#-1,d6
*	move.l	_MaxColorGuaranteed,d0
*	cmpi.l	#2,d0		*max color = 2 ?
*	beq	@f
*num_err:
*	lea	ecolor(OPC),a4	*set error message
*	bra	done
*@@
	moveq.l	#0,d2
	lea	_Green,a0
	lea	_Red,a1
	lea	_Blue,a2
	moveq.l	#1,d3		*color 1 = bitmap on
	bsr	getcol
	bne	@f

	moveq.l	#0,d3		*color 0 = bitmap on
	bsr	getcol
*	beq	num_err
@@
	movea.l	a3,a0		*header address
	move.l	#$408,(a0)+	*magic number 0 / attribute 0
				*/fill plane 2  / display plane 3
	add.w	d2,d2
	move.l	d2,(a0)+	*palet[plane2 / 3]
	lea	shellname(OPC),a1
@@
	move.b	(a1)+,(a0)+
	bne	@b
				*clear unused area
	moveq.l	#(HEADSIZ-18-4)/2-1,d0
@@
	clr.w	(a0)+
	dbra	d0,@b

	move.l	_Width,d5
	move.w	d5,(a0)+
	move.l	_Height,d7
	move.w	d7,(a0)		*width / height

	moveq.l	#1,d0
	tst.l	_fp
	bne	@f		*stdout ?

	move.w	#$20,-(sp)	*file attribute(normal)
	move.l	_File,-(sp)	*file name
	DOS	__CREATE
	addq.w	#6,sp
	tst.l	d0
	bpl	@f

	lea	ecreate(OPC),a4	*set error message
	bra	done
@@
	move.w	d0,d6		*file handle
	moveq.l	#HEADSIZ,d1	*header size
	move.l	d1,-(sp)
	pea	(a3)		*header address
	move.w	d6,-(sp)	*file handle
	DOS	__WRITE
	lea	10(sp),sp
	cmp.l	d0,d1		*wrote exact size ?
	beq	@f
write_err:
	lea	ewrite(OPC),a4	*set error message
	bra	done
@@
	movea.l	_Screen,a3
	movea.l	a3,a0		*head of screen
	movea.l	a3,a1		* (overwrite)
	bra	yent
ylp:
	move.w	d5,d4		*bits per line
	bra	xent
xlp:
	moveq.l	#8-1,d2
	cmp.w	d2,d4		*rest bits >= 8 ?
	bhi	bitlp

	move.w	d4,d2
	subq.w	#1,d2
bitlp:
	add.b	d1,d1		*left shift bit buffer
	tst.b	(a0)+
	sne	d0		*color == 0 ?
	addq.b	#1,d0
	or.b	d0,d1
	dbra	d2,bitlp

	moveq.l	#8,d0
	sub.w	d4,d0
	ble	@f

	lsl.l	d0,d1
@@
	tst.b	d3
	bne	@f

	not.b	d1
@@
	move.b	d1,(a1)+	*virtual gram
	subq.w	#8,d4		*rest bits -= 8
xent:
	bgt	xlp
yent:
	dbra	d7,ylp

	suba.l	a3,a1		*size written
	move.l	a1,-(sp)
	pea	(a3)		*buffer (overwritten)
	move.w	d6,-(sp)	*file handle
	DOS	__WRITE
	lea	10(sp),sp
	cmp.l	a1,d0		*wrote exact size ?
	bne	write_err

	cmpi.w	#1,d6		*stdout ?
	beq	rtn
done:
	tst.l	d6		*file handle
	bmi	@f

	move.w	d6,-(sp)	*file handle
	DOS	__CLOSE
	addq.w	#2,sp
@@
	cmp.w	#0,a4		*error
	beq	rtn

	pea	(a4)		*error message
	jbsr	_error
	addq.w	#4,sp
rtn:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4
	unlk	a6
	rts

	.even
*getcol
*	arg    a0 : palet(green)
*	       a1 : palet(red)
*	       a2 : palet(blue)
*	return d2 : 15bit color value
*	destroy   : d0, d1
getcol:
	move.w	(a0)+,d1	*green
	lsl.w	#5,d1
	moveq.l	#$ffff_fff8,d0
	and.w	(a1)+,d0	*red
	move.b	d0,d1
	add.w	d1,d1
	add.w	d1,d1
	move.w	(a2)+,d0	*blue
	lsr.w	#3,d0
	or.w	d0,d1
	move.w	d1,d2
	rts

	.even
shellname:
	.dc.b	'COMMAND.X',$00
ecolor:
	.dc.b	'not 2 colors',$00
ecreate:
	.dc.b	'cannot create',$00
ewrite:
	.dc.b	'Error in writing',$00

	.even
	.end
